#!/bin/sh
#
# Copyright (c) 2018 Oracle and/or its affiliates. All rights reserved.
# Licensed under the Universal Permissive License v 1.0 as shown at http://oss.oracle.com/licenses/upl.

readonly KUBEDIR="$(cat /usr/local/share/kubeadm/kubeadm-ha/KUBEDIR)"

mkdir -p ${KUBEDIR}

PORT="${2:-"6443"}"
IPVS="${3:-}"

COMMONPORT="8472/udp 10250/tcp 10255/tcp"
if [[ "${1}" = "master" ]]; then
  COMMONPORT="${COMMONPORT} ${PORT}/tcp 2379-2380/tcp 10251/tcp 10252/tcp"
fi

if [[ "${IPVS}" = "ipvs" ]]; then
  COMMONPORT="${COMMONPORT} 443/tcp 53/tcp 53/udp 8080/tcp 6379/tcp"
  KMODULES="ip_vs ip_vs_rr ip_vs_wrr ip_vs_sh nf_conntrack_ipv4"
  for kmod in ${KMODULES}; do
  	modprobe ${kmod}
  done
fi

for port in ${COMMONPORT}; do
  firewall-cmd --add-port=${port}
  firewall-cmd --add-port=${port} --permanent
done
firewall-cmd --add-masquerade
firewall-cmd --add-masquerade --permanent

setenforce 0
sed 's/SELINUX=enforcing/SELINUX=permissive/' -i /etc/selinux/config

/sbin/iptables -P FORWARD ACCEPT
/sbin/sysctl -p /etc/sysctl.d/k8s.conf

systemctl start docker
